/* Example openacc saxpy code for ECE574 -- Spring 2024 */
/* By Vince Weaver <vincent.weaver@maine.edu> */

#include <stdlib.h>
#include <stdio.h>

#include "openacc.h"

void saxpy(int n, float a, const float *x, const float *y, float *restrict z) {

int i;

#pragma acc parallel loop
	for (i = 0; i < n; i++) {
		z[i] = a * x[i] + y[i];
	}
}

int main(int argc, char **argv) {

	/*************************************/
	/* Allocate space on device          */
	/*************************************/

	int N=1000*1000*8;

	float *x,*y,*z;
	float a;
	int i;

#if 0
typedef enum acc_device_t {
  /* Keep in sync with include/gomp-constants.h.  */
  acc_device_current = -1,
  acc_device_none = 0,
  acc_device_default = 1,
  acc_device_host = 2,
  /* acc_device_host_nonshm = 3 removed.  */
  acc_device_not_host = 4,
  acc_device_nvidia = 5,
  acc_device_radeon = 8,
  _ACC_device_hwm,
  /* Ensure enumeration is layout compatible with int.  */
  _ACC_highest = __INT_MAX__,
  _ACC_neg = -1
} acc_device_t;
#endif

	printf("Num devices: %d\n",acc_get_num_devices(acc_device_default));

	a=5.0;

	/* Allocate vectors on CPU */
	x=(float *)malloc(N*sizeof(float));
	y=(float *)malloc(N*sizeof(float));
	z=(float *)malloc(N*sizeof(float));

	/* Initialize the host vectors */
        for(i=0;i<N;i++) {
                x[i]=(float)i;
                y[i]=(float)(10.0*i);
        }

	saxpy(N, a, x, y, z);

	/* results */
        i=100;
        printf("y[%d]=%f, y[%d]=%f\n",i,z[i],N-1,z[N-1]);

        /* y[i]=a*x[i]+y[i] */
        /* 0: a=5, x=0, y=0  ::::::: y=0 */
        /* 1: a=5, x=1, y=10 ::::::: y=15 */
        /* 2: a=5, x=2, y=20 ::::::: y=30 */
        /* 3: a=5, x=3, y=30 ::::::: y=45 */
        /* 4: a=5, x=4, y=40 ::::::: y=60 */
        /* ... */
        /* 100: a=5, x=100, y=1000 y=1500 */

	/* TODO: free everything */


	return 0;
}
